typedef volatile unsigned short vu16;
#define REG_SIOMULTI0 *(vu16*)0x4000120
#define REG_SIOMULTI1 *(vu16*)0x4000122
#define REG_SIOCNT *(vu16*)0x4000128
#define REG_RCNT *(vu16*)0x4000134

#define SNES_B 0x8000
#define SNES_Y 0x4000
#define SNES_SEL 0x2000
#define SNES_START 0x1000
#define SNES_UP 0x0800
#define SNES_DOWN 0x0400
#define SNES_LEFT 0x0200
#define SNES_RIGHT 0x0100
#define SNES_A 0x0080
#define SNES_X 0x0040
#define SNES_L 0x0020
#define SNES_R 0x0010

void initSNESpad() {
	REG_RCNT=0x0000;	//use serial mode
	REG_SIOCNT=0x1001;	//32bit, internalclock
}

int readSNESpad() {
	int i;
	while(REG_SIOCNT&0x80);	//wait for last read
	i=REG_SIOMULTI0;
	if(!i) --i;		//emulator fix (VBA will read 0)
	REG_SIOMULTI0=0;
	REG_SIOMULTI1=1;
	REG_SIOCNT=0x1081;	//begin next read
	return ~i;
}
